【LeetCode热题100】【二分查找】寻找两个正序数组的中位数

题目链接:4. 寻找两个正序数组的中位数 - 力扣(LeetCode)

在两个有序数组中在不合并的前提下寻找他们合并后的中位数,这个可以转换成寻找第k大的数

我们来看看这个第k大的数应该在什么地方,下标从0开始,那么ai前面有i个数,bj前面有j个数

那么如果i+j=k,那么说明ai和bj前面有k个数,如果ai-1<=bj并且bj-1<=ai,这就说明这k个数就是合并后有序的前k个数,那么第k大的数就是ai-1和bj-1之间的较大者

所以可以在a中二分查找符合条件的i,让j=k-i,如果bj-1>ai说明i的位置应该往后挪查找,否则往前查找

这里需要注意j的范围,因为bj-1和bj可以不存在,比如a=123,b=456,如果要找3,那么i=3,j=0,此时bi-1是不存在的,ai也是不存在的,因此0<=j<=m,即0<=k-i<=m,即i<=k,i>=k-m

这样可以二分确定第k大的范围,那么要找中位数,如果总长度是偶数,那么中位数就是中间两个数的平均值,否则就是中间那个数

复制代码
class Solution {
public:
    int findK(vector<int> &nums1, vector<int> &nums2, int k) {
        int left = max(0, int(k - nums2.size())), right = min(k, int(nums1.size()));
        while (left < right) {
            int mid = (left + right) / 2;
            if (nums2[k - mid - 1] > nums1[mid])
                left = mid + 1;
            else
                right = mid;
        }
        return max(left ? nums1[left - 1] : INT_MIN, k - left ? nums2[k - left - 1] : INT_MIN);
    }

    double findMedianSortedArrays(vector<int> &nums1, vector<int> &nums2) {
        int mn = nums1.size() + nums2.size();
        if (mn & 1)
            return findK(nums1, nums2, mn / 2 + 1);
        return (findK(nums1, nums2, mn / 2) + findK(nums1, nums2, mn / 2 + 1)) / 2.0;
    }
};
相关推荐
yi0113 分钟前
LeetCode 3. 无重复字符的最长子串|不定长滑动窗口:什么时候更新最大值?
笔记·python·算法·leetcode·双指针·滑动窗口
y1su11 分钟前
Leetcode 单调栈模板
java·开发语言·数据结构·算法·leetcode
索尔~古德曼25 分钟前
CF(1400-1400&1300-1500)
算法
爱刷碗的苏泓舒33 分钟前
泰勒级数与泰勒展开:GNSS卫地距线性化、Jacobian矩阵与Hessian矩阵
线性代数·算法·矩阵·gnss·雅可比矩阵·卫地距线性化·海森矩阵
垆边人似月.39 分钟前
华为题:每日温度
数据结构·c++·算法
Sylvia-girl1 小时前
堆排序算法
算法·排序算法·c
Peregrine91 小时前
数据结构 - > 树和二叉树
数据结构·算法
我是人✓1 小时前
Java面向对象核心特性深度解析
java·前端·算法
j7~1 小时前
【算法】专题四.前缀和:一维二维模板,配套 LeetCode 真题,结合同余定理、哈希前缀和,搞定子数组与子矩阵区间求和问题。
数据结构·c++·算法·前缀和·优选算法
看浪的路人1 小时前
第1讲:2026 大模型应用开发全景——Prompt / RAG / 微调 / Agent 到底先用哪个
人工智能·算法